﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
	Private form1 As JQueryElement
	Private Result As JQueryElement
	Private AWS_job As HttpJob
	
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	Log("conn")
	form1.RunMethod("ajaxForm", Null)
	ws.Session.SetAttribute("file_upload_sender", Me)
	
	


End Sub
	


Public Sub FileUploaded(parts As Map)
	Dim filePart As Part = parts.Get("file1")
	Result.SetText("Uploading.....")
	Log(filePart.TempFile)
	Result.SetCSS("color", "black")
	'File.Delete("", filePart.TempFile)
	ws.Flush 'this is a server event so we need to explicitly call Flush
	S3_Upload(filePart)
End Sub

'Public Sub AMZNUP (data As InputStream)
'	Log("trying")
'	Amazon_Upload(data)
'End Sub

Public Sub FileError(Message As String)
	Result.SetText("Error uploading file: " & Message)
	Result.SetCSS("color", "red")
	ws.Flush
End Sub

Private Sub WebSocket_Disconnected
	'remove the class instance from the session
	ws.Session.RemoveAttribute("file_upload_sender")
End Sub

Private Sub S3_Upload (filepart As Part)
	AWS_S3.AWS_URI_Is_Path_Style = True
	AWS_S3.AWS_Access_Key_ID = "0021b7c45cae0a20000000004"
	AWS_S3.AWS_Secret_Access_Key = "K0025WFMCY2jv9GJ9o3Og7FQruzJn0M"
	AWS_S3.AWS_Region = "s3.us-west-002"
	AWS_S3.AWS_End_Point = "s3.us-west-002.backblazeb2.com"
	AWS_S3.AWS_S3_Bucket_Name = "B4Xtest"
	'AWS_S3.AWS_S3_File_Name = ""
	'AWS_S3.AWS_S3_HttpMethod = "GET"
	

	AWS_S3.AWS_S3_File_Name = "File"&DateTime.Now&filepart.SubmittedFilename
	AWS_S3.AWS_S3_HttpMethod = "PUT"

	AWS_S3.AWS_S3_Query_map.Initialize
	AWS_S3.AWS_S3_Query_map.Clear

	Private wrk_in As InputStream
	
	wrk_in = File.OpenInput("",filepart.TempFile)
	Private wrk_out As OutputStream
	wrk_out.InitializeToBytesArray(1000)
	File.Copy2(wrk_in, wrk_out)
	wrk_in.Close
	wrk_out.Close
	AWS_S3.AWS_S3_Payload = wrk_out.ToBytesArray

	AWS_S3.AWS_S3_GMT_DateTime = DateTime.Now

	AWS_S3.AWS_S3_OtherHeader_map.Initialize
	AWS_S3.AWS_S3_OtherHeader_map.Clear
	AWS_S3.AWS_S3_OtherHeader_map.Put("Content-Type", "application/x-www-form-urlencoded")
	AWS_S3.AWS_S3_OtherHeader_map.Put("Content-Length", NumberFormat2(AWS_S3.AWS_S3_Payload.Length, 1, 0, 0, False))
	AWS_S3.AWS_S3_OtherHeader_map.Put("x-amz-meta-author", "B4X")
	AWS_S3.AWS_S3_OtherHeader_map.Put("Expect", "100-continue")
	
	Log(AWS_S3.URI)

	'Set up httpjob
	AWS_job.Initialize("AWS_job2", Me)
	AWS_job.PutBytes(AWS_S3.URI, AWS_S3.AWS_S3_Payload)

	'Retrieve full header map
	Private wk_hdr_map As Map
	wk_hdr_map.Initialize
	wk_hdr_map = AWS_S3.FullHeaderMap

	Private wrk_ptr As Int

	'For each key, value pair of full header map...
	For wrk_ptr = 0 To wk_hdr_map.Size - 1
   
		'If not host header...
		If wk_hdr_map.GetKeyAt(wrk_ptr) <> "host" Then
       
			'Add it to httpjob
			AWS_job.GetRequest.SetHeader(wk_hdr_map.GetKeyAt(wrk_ptr), wk_hdr_map.GetValueAt(wrk_ptr))

			Log(wk_hdr_map.GetKeyAt(wrk_ptr) & ", " & wk_hdr_map.GetValueAt(wrk_ptr))

		End If

	Next
	
	Log(AWS_S3.Authorization)

	'Add Authorization header to httpjob
	'AWS_job.GetRequest.SetContentType("application/x-www-form-urlencoded")
	AWS_job.GetRequest.SetHeader("Authorization", AWS_S3.Authorization)
	
	'Log("https://uerca01.s3.us-west-002.backblazeb2.com/"&AWS_S3.AWS_S3_File_Name)
	
End Sub

'Return true to allow the default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub JobDone(Job As HttpJob)
	
	Log("JobName = " & Job.JobName & ", Success = " & Job.Success)
	
	If Job.Success = True Then
	
		Select Job.JobName
	
			Case "AWS_job"

				'Set up map to hold XML response
				Private XML_response_map As Map
				XML_response_map.Initialize
				
				'Suck XML response into XML_response_map
				Private xm As Xml2Map
				xm.Initialize
				XML_response_map = xm.Parse(Job.GetString)
				Log("XML: "&XML_response_map)
				Log("Job: "&Job.GetString)
				'Convert XML response to JSON
				Private JSON_response As JSONGenerator
				JSON_response.Initialize(XML_response_map)
				
				'Log JSON resonse
				Log(JSON_response.ToPrettyString(4))
			
			Case "AWS_job2"
           
				Log(">>>>>>>>>>>>>>>>>>>Uploaded<<<<<<<<<<<<<<<<<<<<")
				Result.SetText("UPLOADED!")
				
		End Select
		
	Else
		
		Log("Error: " & Job.ErrorMessage)
		Result.SetText("Error: " & Job.ErrorMessage)
	End If
	
	Job.Release
	ws.Flush
	
	
End Sub